import java.net.*;
import java.util.*;
import org.apache.soap.*;
import org.apache.soap.rpc.*;
public class Client
   {
   public static void main( String[] args ) throws Exception
     {
     URL url = new URL( "http://localhost/soap/servlet/rpcrouter" );
     String urn = "urn:demo1:exchange";
     Call call = new Call(); // prepare to invoke the Service
     call.setTargetObjectURI( urn );
     call.setMethodName( "getRate" );
     call.setEncodingStyleURI( Constants.NS_URI_SOAP_ENC );  // the default
     Vector v = new Vector();
     v.addElement( new Parameter( "BaseRate", String.class, "12.34", null ) );
     v.addElement( new Parameter( "ReplacementCostFactor", String.class, "56.78", null ) );
     call.setParams( v );
     try
       {
       System.out.println( "Service invoked:\n" + "  URL= " +
          url + "\n  URN= " + urn );
       Response response = call.invoke( url, "" ); // invoke the Service
       if( !response.generatedFault() )
         {
         Parameter r = response.getReturnValue(); // response was OK
         System.out.println( "Result= " + r.getValue() );
         }
       else
         {
         Fault f = response.getFault(); // error
         System.err.println( "Fault= " + f.getFaultCode() + ", " +
           f.getFaultString() );
         }
       }
     catch( SOAPException e ) // error sending call
       {
       System.err.println( "SOAPException= " + e.getFaultCode() + ", " +
         e.getMessage() );
       }
     }
   }